package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLUnionPWQPolynomialFold_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLUnionPWQPolynomialFold extends JNIObject  {
	
	/* @generated */
	protected ISLUnionPWQPolynomialFold(long ptr) {
		/*** PROTECTED REGION ID(ISLUnionPWQPolynomialFold_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLUnionPWQPolynomialFold build(long ptr) {
		return new ISLUnionPWQPolynomialFold(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLUnionPWQPolynomialFold_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_union_pw_qpolynomial_fold_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLUnionPWQPolynomialFold upwqpf, int format) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_qpolynomial_fold_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_qpolynomial_fold_to_string(getNativePtr(upwqpf), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_union_pw_qpolynomial_fold_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_fold_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_union_pw_qpolynomial_fold_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_fold_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_fold_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_union_pw_qpolynomial_fold_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_fold_copy 
	 * 
	 * @generated
	**/
	public ISLUnionPWQPolynomialFold copy() {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_fold_copy) DISABLED START ***/
		ISLUnionPWQPolynomialFold res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionPWQPolynomialFold.build(ISLNative.isl_union_pw_qpolynomial_fold_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_fold_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_fold_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_union_pw_qpolynomial_fold_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_fold_gist 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLUnionPWQPolynomialFold gist(ISLUnionSet context) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_fold_gist) DISABLED START ***/
		ISLUnionPWQPolynomialFold res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLUnionPWQPolynomialFold.build(ISLNative.isl_union_pw_qpolynomial_fold_gist(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_fold_coalesce 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWQPolynomialFold coalesce() {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_fold_coalesce) DISABLED START ***/
		ISLUnionPWQPolynomialFold res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWQPolynomialFold.build(ISLNative.isl_union_pw_qpolynomial_fold_coalesce(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_fold_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet domain() {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_fold_domain) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_pw_qpolynomial_fold_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_fold_intersect_domain 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionPWQPolynomialFold intersectDomain(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_fold_intersect_domain) DISABLED START ***/
		ISLUnionPWQPolynomialFold res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionPWQPolynomialFold.build(ISLNative.isl_union_pw_qpolynomial_fold_intersect_domain(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_fold_intersect_params 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLUnionPWQPolynomialFold intersectParams(ISLSet set) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_fold_intersect_params) DISABLED START ***/
		ISLUnionPWQPolynomialFold res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLUnionPWQPolynomialFold.build(ISLNative.isl_union_pw_qpolynomial_fold_intersect_params(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_fold_intersect_domain_wrapped_domain 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionPWQPolynomialFold intersectDomainWrappedDomain(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_fold_intersect_domain_wrapped_domain) DISABLED START ***/
		ISLUnionPWQPolynomialFold res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionPWQPolynomialFold.build(ISLNative.isl_union_pw_qpolynomial_fold_intersect_domain_wrapped_domain(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_fold_intersect_domain_wrapped_range 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionPWQPolynomialFold intersectDomainWrappedRange(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_fold_intersect_domain_wrapped_range) DISABLED START ***/
		ISLUnionPWQPolynomialFold res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionPWQPolynomialFold.build(ISLNative.isl_union_pw_qpolynomial_fold_intersect_domain_wrapped_range(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLUnionPWQPolynomialFold_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
